/*---------------------------------------------------------------------*/
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <signal.h>
#include <vga.h>
#include <vgagl.h>
#include <vgakeyboard.h>
#include "datatype.h"
#include "moto.h"
/*---------------------------------------------------------------------*/
/*    #define	DEBUG     */
/*---------------------------------------------------------------------*/
UCHAR *cbuf;
UCHAR *csbuf;
UINT	sys_time;
int stage=0;

int	scroll_x;
int	scroll_y;
extern COURSE course[16];

char *username;

char pal[16*3] = {
0,0,0,		/* car color */
7,24,63,
63,63,63,
0,0,0,
63,0,0,
44,0,0,
28,28,28,
0,0,0,		/* 7  space */
48,48,48,	/* 8  Chk point 1 */
48,48,48,	/* 9  Chk point 2 */
48,48,48,	/* 10 Chk point 3 */
48,48,48,	/* 11 Chk point 4 */
0,16,0,		/* 12 no use */
0,60,0,		/* 13 goal */
24,24,24,		/* 14 speed down */
48,48,48,	/* 15 road */
};

MOTO m;

short high[16*10];
UCHAR highname[10*16*10];
UCHAR video[16*VIDEO_INT];

UCHAR nowvideo[VIDEO_INT];
UCHAR *proname[8] = {"SHUMACHER","HILL","ALESI","BERGER","COULTHARD","HERBERT","HAKKINEN","UKYO!"};

GraphicsContext virtualscreen;
GraphicsContext physicalscreen;
/*---------------------------------------------------------------------*/
int main(int argc,char **argv);
void delay(void);
void loadbitmap(char *fname,UCHAR *buf);
static void timeout();
void scroll_set(int x,int y);
void joy_set(MOTO *m);
void speedmeter_disp(int x,int y,int speed);
void moto_main(int mode);
void score_read(UCHAR *fname);
void score_write(UCHAR *fname);
int menu(void);
void menu_disp(int no);
void top_ranking(void);
int score_ranking(int s,int time);
void wait_vsync(void);

extern void time_disp(int x,int y,int time,int color);
extern void initfont(void);
extern void dir_move(MOTO *m);
extern int speed_get(int s);
extern void strdisp(int x,int y,char *str,int color);
extern void disp_ud(int x,int y,int d,int color);
extern void moto_init(MOTO *m);
extern void moto_move(MOTO *m);
/*---------------------------------------------------------------------*/
static void
timeout()
{	keyboard_close();
	vga_setmode(TEXT);
	exit(1);
}

void
loadbitmap(char *fname,UCHAR *buf)
{	FILE *f;
	void *bufp;
	UCHAR dat[256];

	strcpy(dat,INSTALLDIR);
	strcat(dat,fname);
	f=fopen(dat,"rb");
	bufp=buf;
	for (;;)
	{	int	count=fread(bufp,1,8192,f);
		if (count==0)
			break;
		if (feof(f))
			break;
		bufp += count;
	}
	fclose(f);
}

void
speedmeter_disp(int x,int y,int speed)
{
	gl_line(x   ,y,x+40,y+20,3);
	gl_line(x+20,y,x+40,y+20,3);
	gl_line(x+40,y,x+40,y+20,3);
	gl_line(x+60,y,x+40,y+20,3);
	gl_line(x+80,y,x+40,y+20,3);
	speed>>=2;
	if (speed>80)
	{	speed=80;
	}
	gl_line(x+speed,y,x+40,y+20,13);
}

void
moto_main(int mode)
{	int	i;
	int	rank;

	if (mode == MODE_NORMAL)
	{	m.player = MODE_NORMAL;
	}
	else if (mode == MODE_REPLAY)
	{	m.player = MODE_REPLAY;
	}
	else if (mode == MODE_REPLAY_TOP)
	{	m.player = MODE_REPLAY_TOP;
	}
	m.x   = course[stage].start_x;
	m.y   = course[stage].start_y;
	m.dir = course[stage].start_dir;
    m.ch = ((m.dir+0x4)&0xff)>>3;
	m.speed = 0;
	m.quit = 0;
	m.videop = 0;
	moto_init(&m);
	sys_time = 0;

	scroll_set(m.x-160,m.y-100);

	if (mode == MODE_NORMAL)
	{	for (i=0;i<60*3+10;i++)
		{	gl_putboxpart(scroll_x,scroll_y,320,200,640,400,csbuf,scroll_x,scroll_y);
			gl_putboxmask(m.x-16,m.y-16,32,32,cbuf+m.ch*32*32);
			speedmeter_disp(scroll_x,scroll_y,m.speed);
			time_disp(30,0,m.time,C_WHITE);
			disp_ud(20,12,3-i/60,C_BLACK+i&7);
			strdisp(12,0,"RECORD:",C_GREEN);
			time_disp(20,0,high[stage*10],C_GREEN);
			delay();
		}
	}

	while (m.quit==0)
	{	sys_time++;

		joy_set(&m);
		moto_move(&m);
		dir_move(&m);

		scroll_set(m.x-160,m.y-100);
		gl_putboxpart(scroll_x,scroll_y,320,200,640,400,csbuf,scroll_x,scroll_y);
		m.color = gl_getpixel(m.x,m.y);
		gl_putboxmask(m.x-16,m.y-16,32,32,cbuf+m.ch*32*32);
		speedmeter_disp(scroll_x,scroll_y,m.speed);
		time_disp(30,0,m.time,C_WHITE);
		strdisp(12,0,"RECORD:",C_GREEN);
		time_disp(20,0,high[stage*10],C_GREEN);
		delay();

		if ((mode != MODE_NORMAL)&&(m.videop >= VIDEO_INT))
			break;
		if (m.joy & SWD_1P)
		{	m.time = 20000;
			break;
		}
	}
	if (mode == MODE_NORMAL)
	{	if (10 > (rank = score_ranking(stage,m.time)))
		{	for (i=0;i<60*3+10;i++)
			{	gl_putboxpart(scroll_x,scroll_y,320,200,640,400,csbuf,scroll_x,scroll_y);
				gl_putboxmask(m.x-16,m.y-16,32,32,cbuf+m.ch*32*32);
				speedmeter_disp(scroll_x,scroll_y,m.speed);
				time_disp(30,0,m.time,C_WHITE);
				strdisp(12,0,"RECORD:",C_GREEN);
				time_disp(20,0,high[stage*10],C_GREEN);
				strdisp(10,12,(rank==0)?"You get new record!!!!!!!!":
										"You get TOP 10 SCORE!!!",C_BLACK+(i&7));
				delay();
			}
		}
	}
	scroll_x=0;
	scroll_y=0;
}

void
wait_vsync(void)
{
	while (clock()&1)	;
}

void
delay(void)
{
	wait_vsync();
	/* Copy window to screen. */
	gl_copyboxtocontext(scroll_x,scroll_y,WINWIDTH,WINHEIGHT,&physicalscreen,0,0);
}

void
scroll_set(int x,int y)
{
	scroll_x=x;
	scroll_y=y;
	if (scroll_x < 0)
		scroll_x = 0;
	if (scroll_x > VWIDTH - WINWIDTH)
		scroll_x = VWIDTH - WINWIDTH;
	if (scroll_y < 0)
		scroll_y = 0;
	if (scroll_y > VHEIGHT - WINHEIGHT)
		scroll_y = VHEIGHT - WINHEIGHT;
}

void
score_read(UCHAR *fname)
{
	int	i;
	FILE	*fp;

	for (i=0;i<VIDEO_INT*16;i++)
	{	video[i] = 0;
	}
	for (i=0;i<16*10;i++)
	{	high[i] = 60*100-1;
		strcpy(&highname[i*10],proname[rand()&7]);
	}
	fp = fopen(fname,"rb");
	if (fp != NULL)
	{	fread(high,1,2*16*10,fp);
		fread(highname,1,10*16*10,fp);
		fread(video,16,VIDEO_INT,fp);
		fclose(fp);
	}
}

void
score_write(UCHAR *fname)
{
	int	i;
	FILE	*fp;

	fp = fopen(fname,"wb+");
	if (fp != NULL)
	{	fwrite(high,1,2*16*10,fp);
		fwrite(highname,1,10*16*10,fp);
		fwrite(video,16,VIDEO_INT,fp);
		fclose(fp);
	}
}

int
main(int argc,char **argv)
{	UCHAR *vbuf;
	int	i,mode;
	FILE *fp;
	UCHAR	fname[256];

	username=getenv("USER");
	strcpy(fname,INSTALLDIR);
	if (argc != 1)
	{	strcat(fname,argv[1]);
	}
	else
	{	strcat(fname,"tinyf1.sco");
	}
	score_read(fname);

	stage = 0;

	vga_init();

	vbuf = malloc(VWIDTH * VHEIGHT);
	cbuf = malloc(1024*32);
	csbuf = malloc(VWIDTH * VHEIGHT);

	gl_setcontextvirtual(VWIDTH, VHEIGHT, 1, 8, vbuf);

	vga_setmode(G320x200x256);

	gl_setpalettecolors(0,16,pal);

	initfont();

	gl_getcontext(&virtualscreen);
	gl_setcontextvga(G320x200x256);
	gl_getcontext(&physicalscreen);
	gl_setcontext(&virtualscreen);

	if (keyboard_init())
	{	printf("Could not initialize keyboard.\n");
		exit(1);
	}
	keyboard_translatekeys(TRANSLATE_CURSORKEYS|TRANSLATE_KEYPADENTER);

#ifdef DEBUG
	signal(SIGALRM,timeout);
	signal(SIGSEGV,timeout);

	alarm(60*2);
#endif

	loadbitmap("f1char.bmp",cbuf);

	while (1)
	{	if (-1 == (mode = menu()))
		{	break;
		}
		moto_main(mode);
	}

	score_write(fname);

	keyboard_close();
	free(csbuf);
	free(cbuf);
	free(vbuf);
	vga_setmode(TEXT);
	return(0);
}

void
joy_set(MOTO *m)
{
	m->joy=0;
	keyboard_update();
	if ((m->player == MODE_NORMAL)||(m->player == MODE_KEY))
	{	if (keyboard_keypressed(SCANCODE_CURSORRIGHT))	m->joy|=RIGHT_1P;
		if (keyboard_keypressed(SCANCODE_CURSORLEFT))	m->joy|=LEFT_1P;
		if (keyboard_keypressed(SCANCODE_CURSORDOWN))	m->joy|=DOWN_1P;
		if (keyboard_keypressed(SCANCODE_CURSORUP))		m->joy|=UP_1P;
		if (keyboard_keypressed(SCANCODE_LEFTCONTROL))	m->joy|=SWA_1P;
		if (keyboard_keypressed(SCANCODE_LEFTALT))		m->joy|=SWB_1P;
		if (keyboard_keypressed(SCANCODE_ENTER))		m->joy|=SWC_1P;
		if (keyboard_keypressed(SCANCODE_ESCAPE))		m->joy|=SWD_1P;
		m->joyj = m->joy & (~(m->joysav));
		if (m->player == MODE_NORMAL)
		{	if (m->videop < VIDEO_INT)
			{	nowvideo[m->videop++] = m->joy;
			}
		}
	}
	else if ((m->player == MODE_REPLAY)&&(m->videop < VIDEO_INT))
	{	m->joy = nowvideo[m->videop++];
		if (keyboard_keypressed(SCANCODE_ESCAPE))		m->joy|=SWD_1P;
	}
	else if ((m->player == MODE_REPLAY_TOP)&&(m->videop < VIDEO_INT))
	{	m->joy = video[stage*VIDEO_INT+m->videop++];
		if (keyboard_keypressed(SCANCODE_ESCAPE))		m->joy|=SWD_1P;
	}

	m->joysav = m->joy;
	return;
}

int
menu(void)
{	int	ret;
	static int	menu=0;
	UCHAR	key;
	int	x=0,y=0;
	int	dir=0;

	loadbitmap(course[stage].fname,csbuf);

	scroll_set(x,y);

	m.player = MODE_KEY;
	while (1)
	{	gl_putboxpart(scroll_x,scroll_y,320,200,640,400,csbuf,scroll_x,scroll_y);
		menu_disp(menu);
		delay();
		switch(dir)
		{	case 0:
				x+=8;
				if (x>=VWIDTH-320)	dir++;
				break;
			case 1:
				y+=8;
				if (y>=VHEIGHT-200)	dir++;
				break;
			case 2:
				x-=8;
				if (x<=0)		dir++;
				break;
			case 3:
				y-=8;
				if (y<=0)		dir=0;
				break;
		}
		scroll_set(x,y);
		joy_set(&m);
		key = m.joyj;
		if (m.joyj&UP_1P)
		{	menu = (menu-1)&3;
		}
		else if (m.joyj&DOWN_1P)
		{	menu = (menu+1)&3;
		}
		else if (m.joyj&LEFT_1P)
		{	stage = (stage-1)&0x0f;
			loadbitmap(course[stage].fname,csbuf);
		}
		else if (m.joyj&RIGHT_1P)
		{	stage = (stage+1)&0x0f;
			loadbitmap(course[stage].fname,csbuf);
		}
		else if (m.joyj&SWC_1P)
		{	switch (menu)
			{	case 0:
					return(MODE_NORMAL);
				case 1:
					return(MODE_REPLAY);
				case 2:
					return(MODE_REPLAY_TOP);
				case 3:
					return(-1);
			}
		}
	}
}

void
menu_disp(int no)
{
	top_ranking();
	disp_ud(4,17,stage+1,C_CYAN);
	strdisp(0,17,"START",(no==0)?C_RED:C_WHITE);
	strdisp(10,17,"STAGE",(no==0)?C_RED:C_WHITE);
	strdisp(0,19,"replay",(no==1)?C_RED:C_WHITE);
	strdisp(0,21,"replay top",(no==2)?C_RED:C_WHITE);
	strdisp(0,23,"EXIT",(no==3)?C_RED:C_WHITE);
	score_ranking(stage,-1);
}

void
top_ranking(void)
{
	int	s,len,color;

	for (s=0;s<16;s++)
	{	color = (stage == s)?C_RED:C_CYAN;
		disp_ud(18,s,s+1,color);
		strdisp(30,s,&highname[s*10*10],color);
		time_disp(23,s,high[s*10],C_GREEN);
	}
}

int
score_ranking(int s,int time)
{	int		y,i,j;
	int		h=10;
	int		len;
	UCHAR	dat[16];

	if (time != -1)
	{	for (i=0;i<10;i++)
		{	if (high[s*10+i] > time)
			{	for (j=8;j>=i;j--)
				{	high[s*10+j+1] = high[s*10+j];
					strcpy(&highname[(s*10+j+1)*10],&highname[(s*10+j)*10]);
				}
				high[s*10+i] = time;
				h = i;
				strcpy(&highname[(s*10+i)*10],username);
				break;
			}
		}
		if (h == 0)
		{	memcpy(&video[stage*VIDEO_INT],nowvideo,VIDEO_INT);
		}
	}
	else
	{	for (y=0;y<10;y++)
		{	sprintf(dat,"%d",y+1);
			strdisp(0,y,dat,C_RED);
			strdisp(3,y,&highname[(s*10+y)*10],C_RED);
			time_disp(13,y,high[s*10+y],C_WHITE);
		}
	}
	return(h);
}

/* EOF */
