/*---------------------------------------------------------------------*/
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <signal.h>
#include <vga.h>
#include <vgagl.h>
#include <vgakeyboard.h>
#include "datatype.h"
#include "moto.h"
/*---------------------------------------------------------------------*/
#define VWIDTH 640
#define VHEIGHT 400
/*---------------------------------------------------------------------*/
#define WINWIDTH 320
#define WINHEIGHT 200
/*---------------------------------------------------------------------*/
COURSE course[16] = {
/* name             startx  starty  startdir */
"suzuka.bmp",       418,    59,     0,
"monaco.bmp",       126,    49,     0,
"italian.bmp",      228,    97,     0,
"brazilia.bmp",     289,    77,     0x80,
"spanish.bmp",      69,     92,     0,
"mexican.bmp",      77,     72,     0,
"sanmarin.bmp",     348,    86,     0x80,
"french.bmp",       170,    136,    0,
"canadian.bmp",     397,    111,    0,
"british.bmp",      229,    59,     0,
"german.bmp",       62,     278,    0xc0,
"hungaria.bmp",     114,    229,    0xc0,
"belgian.bmp",      453,    246,    0,
"portugue.bmp",     224,    71,     0,
"australi.bmp",     120,    176,    0,
"okayama.bmp",      215,    90,     0,
};
/*---------------------------------------------------------------------*/
void
moto_init(MOTO *m)
{	m->time = 0;
	m->chk = 0;
}

void
moto_move(MOTO *m)
{	int	i,max;

	if (m->joy & LEFT_1P)	m->dir-=2;
	if (m->joy & RIGHT_1P)	m->dir+=2;
	if (m->speed<80*3)
	{	if (m->joy & SWA_1P)
		{	m->speed++;
		}
	}
	if (m->speed>10)
	{	if (m->joy & SWB_1P)
		{	m->speed-=3;
		}
	}

	if (m->x < 16)
	{	m->x=16;
		m->dir+=0x80;
	}
	if (m->y < 16)
	{	m->y=16;
		m->dir+=0x80;
	}
	if (m->x > VWIDTH-16)
	{	m->x=VWIDTH-16;
		m->dir+=0x80;
	}
	if (m->y > VHEIGHT-16)
	{	m->y=VHEIGHT-16;
		m->dir+=0x80;
	}
	m->time++;
	if (m->color == 14)
	{	m->time++;
		if (m->speed > 10)
		{	m->speed=10;
		}
	}
	if (m->color == 8)
	{	if (m->chk == 0)
		{	m->chk |= CHK_P1;
		}
	}
	if (m->color == 9)
	{	if (m->chk == CHK_P1)
		{	m->chk |= CHK_P2;
		}
	}
	if (m->color == 10)
	{	if (m->chk == CHK_P1+CHK_P2)
		{	m->chk |= CHK_P3;
		}
	}
	if (m->color == 11)
	{	if (m->chk == CHK_P1+CHK_P2+CHK_P3)
		{	m->chk |= CHK_P4;
		}
	}

	if ((m->color == 13)&&(m->chk&CHK_P4))
	{	m->quit=1;
	}
	m->dir &= 0xff;
	m->ch = ((m->dir+0x4)&0xff)>>3;
}

/* EOF */
