/*---------------------------------------------------------------------*/
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <signal.h>
#include <vga.h>
#include <vgagl.h>
#include <vgakeyboard.h>
#include "datatype.h"
#include "sincos.h"
#include "moto.h"
#include "speed.h"
/*---------------------------------------------------------------------*/
extern int scroll_x;
extern int scroll_y;
extern int sys_time;

static UCHAR fontbuf[8][256*8*8];

static char fontcolor[8*3]={
0,0,0,		/* C_BLACK */
0,0,63,		/* C_BLUE */
63,0,0,		/* C_RED */
63,0,63,	/* C_PURPLE */
0,63,0,		/* C_GREEN */
0,63,63,	/* C_CYAN */
63,63,0,	/* C_YELLOW */
63,63,63,	/* C_WHITE */
};
/*---------------------------------------------------------------------*/
void dir_move(MOTO *m);
int speed_get(int s);
void initfont(void);
void strdisp(int x,int y,char *str,int color);
void disp_ud(int x,int y,int d,int color);
void time_disp(int x,int y,int time,int color);
/*---------------------------------------------------------------------*/
void
dir_move(MOTO *m)
{	int	x,y;

	x = (cos_tbl[m->dir] * m->speed)>>12;
	y = (sin_tbl[m->dir] * m->speed)>>12;
	m->x += speed_get(x);
	m->y += speed_get(y);

	if (m->x<16)
	{	m->x=16;
	}
	if (m->x>VWIDTH-16)
	{	m->x = VWIDTH-16;
	}
	if (m->y<16)
	{	m->y=16;
	}
	if (m->y>VHEIGHT-16)
	{	m->y = VHEIGHT-16;
	}
}

int
speed_get(int s)
{	int	d;
	static UCHAR mask8[8]={0x80,0x40,0x20,0x10,8,4,2,1};

	d=(s>>6);
	s&=0x3f;
	d += (speed_tbl[(s<<3)+((sys_time&0x3f)>>3)]&mask8[sys_time&7])?1:0;
	return(d);
}

void
initfont(void)
{	int	i;

	for (i=0;i<8;i++)
	{	gl_expandfont(8,8,C_BLACK+i,gl_font8x8,&fontbuf[i][0]);
	}
	gl_setfont(8,8,&fontbuf[0][0]);
	gl_setpalettecolors(C_BLACK,8,fontcolor);
	gl_setwritemode(WRITEMODE_MASKED);
}

void
strdisp(int x,int y,char *str,int color)
{
	gl_setfont(8,8,&fontbuf[color&7][0]);
	gl_write(scroll_x+x*8,scroll_y+y*8,str);
}

void
disp_ud(int x,int y,int d,int color)
{
	UCHAR	dat[16];

	gl_setfont(8,8,&fontbuf[color&7][0]);
	sprintf(dat,"%4d",d);
	gl_write(scroll_x+x*8,scroll_y+y*8,dat);
}

void
time_disp(int x,int y,int time,int color)
{	int h,l;
	char str[16];

	gl_setfont(8,8,&fontbuf[color&7][0]);
	h = time/60;
	l = time%60;
	l = l*100/60;
	sprintf(str,"%3d:%02d",h,l);
	gl_write(scroll_x+x*8,scroll_y+y*8,str);
}

/* EOF */
